## cgal 6.1.1

=== CMakeLists.txt ===
# Top level CMakeLists.txt for CGAL
# The name of our project is "CGAL".  CMakeLists files in this project can
# refer to the root source directory of the project as ${CGAL_SOURCE_DIR} or
# ${CGAL_SOURCE_DIR} and to the root binary directory of the project as
# ${CGAL_BINARY_DIR} or ${CGAL_BINARY_DIR}.
if(NOT PROJECT_NAME)
  cmake_minimum_required(VERSION 3.12...3.31)
  project(CGAL CXX C)
endif()

# Fix a bug: `try_compile` should use `CMAKE_EXE_LINKER_FLAGS`.
# That variable can contain important flags like
#
#     -static-libstdc++ -static-libgcc
#
# Use GNUInstallDirs to get canonical paths
include(GNUInstallDirs)
#--------------------------------------------------------------------------------------------------
#--------------------------------------------------------------------------------------------------
#
#                                    -= PACKAGE SETUP =-
#
#--------------------------------------------------------------------------------------------------

if(CGAL_BRANCH_BUILD)

  message(STATUS "Build CGAL from ${CGAL_SCM_NAME}-branch: ${CGAL_SCM_BRANCH_NAME}")

  # list packages
  file(
    GLOB CGAL_CONFIGURED_PACKAGES
    RELATIVE ${CGAL_SOURCE_DIR}
    "${CGAL_SOURCE_DIR}/*")
  list(SORT CGAL_CONFIGURED_PACKAGES)
  list(REMOVE_ITEM CGAL_CONFIGURED_PACKAGES copyright CMakeLists.txt .svn .git)

  # detect and remove not existing package-directories
  foreach(package ${CGAL_CONFIGURED_PACKAGES})
    if(NOT IS_DIRECTORY "${CGAL_SOURCE_DIR}/${package}")
      list(APPEND CGAL_WRONG_PACKAGES ${package})
    elseif(NOT EXISTS
           "${CGAL_SOURCE_DIR}/${package}/package_info/${package}/maintainer")
      list(APPEND CGAL_WRONG_PACKAGES ${package})
    endif()
  endforeach()

  find_program(
    CGAL_CREATE_CMAKE_SCRIPT cgal_create_cmake_script HINT
    ${CGAL_SOURCE_DIR}/Scripts/scripts
    DOC "Script cgal_create_cmake_script, that creates CMakeLists.txt files"
    NO_DEFAULT_PATH NO_CMAKE_ENVIRONMENT_PATH)

  if(DEFINED CGAL_WRONG_PACKAGES)
    message(STATUS "Removed not-a-package: ${CGAL_WRONG_PACKAGES}")
    list(REMOVE_ITEM CGAL_CONFIGURED_PACKAGES ${CGAL_WRONG_PACKAGES})
  endif()

  set(CGAL_CONFIGURED_PACKAGES_NAMES ${CGAL_CONFIGURED_PACKAGES})
  set(CGAL_CONFIGURED_PACKAGES)
  foreach(package ${CGAL_CONFIGURED_PACKAGES_NAMES})
    list(APPEND CGAL_CONFIGURED_PACKAGES "${CGAL_SOURCE_DIR}/${package}")
  endforeach()

  set(CGAL_INSTALLATION_PACKAGE_DIR
      "${CGAL_SOURCE_DIR}/Installation"
      CACHE INTERNAL "Directory containing the Installation package")
  set(CGAL_MAINTENANCE_PACKAGE_DIR
      "${CGAL_SOURCE_DIR}/Maintenance"
      CACHE INTERNAL "Directory containing the Maintenance package")
  set(CGAL_CORE_PACKAGE_DIR
      "${CGAL_SOURCE_DIR}/Core"
      CACHE INTERNAL "Directory containing the Core package")
  set(CGAL_GRAPHICSVIEW_PACKAGE_DIR
      "${CGAL_SOURCE_DIR}/GraphicsView"
      CACHE INTERNAL "Directory containing the GraphicsView package")
  file(GLOB INCLUDE_CGAL_QT_DIRECTORIES "${CGAL_SOURCE_DIR}/*/include/CGAL/Qt")
  message(STATUS "Include CGAL/Qt directories: ${INCLUDE_CGAL_QT_DIRECTORIES}")

  message(STATUS "Installation package directory: ${CGAL_INSTALLATION_PACKAGE_DIR}")
  message(STATUS "Maintenance package directory: ${CGAL_MAINTENANCE_PACKAGE_DIR}")
  message(STATUS "Core package directory: ${CGAL_CORE_PACKAGE_DIR}")

else(CGAL_BRANCH_BUILD)

  # get release name
  file(TO_CMAKE_PATH ${CGAL_SOURCE_DIR} CMAKE_SOURCE_CDIR)
  string(REGEX REPLACE "^/" "" CMAKE_SOURCE_DDIR ${CMAKE_SOURCE_CDIR})
  string(REPLACE "/" ";" CMAKE_SOURCE_PDIR ${CMAKE_SOURCE_DDIR})
  list(GET CMAKE_SOURCE_PDIR -1 CGAL_RELEASE_NAME)
  message(STATUS "Build CGAL from release in directory ${CGAL_RELEASE_NAME}")

  set(CGAL_CONFIGURED_PACKAGES_NAMES ${CGAL_RELEASE_NAME})

  # list packages
  set(CGAL_CONFIGURED_PACKAGES "${CGAL_SOURCE_DIR}")

  set(CGAL_INSTALLATION_PACKAGE_DIR
      "${CGAL_SOURCE_DIR}"
      CACHE INTERNAL "Directory containing the Installation package")
  set(CGAL_MAINTENANCE_PACKAGE_DIR
      "${CGAL_SOURCE_DIR}"
      CACHE INTERNAL "Directory containing the Maintenance package")
  set(CGAL_CORE_PACKAGE_DIR
      "${CGAL_SOURCE_DIR}"
      CACHE INTERNAL "Directory containing the Core package")
  set(CGAL_GRAPHICSVIEW_PACKAGE_DIR
      "${CGAL_SOURCE_DIR}"
      CACHE INTERNAL "Directory containing the GraphicsView package")
  set(INCLUDE_CGAL_QT_DIRECTORIES "${CGAL_SOURCE_DIR}/include/CGAL/Qt")

# Enable testing with CGAL_ENABLE_TESTING. Before CGAL-6.0, users would enable
# the tests by specifying BUILD_TESTING. For compatibility, If BUILD_TESTING is
# set, that is the default value for CGAL_ENABLE_TESTING. Otherwise, the default
# value is OFF.
option(CGAL_ENABLE_TESTING "Build the testing tree." ${BUILD_TESTING})
  if(CGAL_ENABLE_TESTING)
    enable_testing()
  endif()
endif(CGAL_BRANCH_BUILD)

#allow to force disabling boost multiprecision support
option(CGAL_DO_NOT_USE_BOOST_MP "Disable the support of boost multiprecision library" FALSE)

#message(STATUS "Packages found: ${CGAL_CONFIGURED_PACKAGES}")

list(SORT CGAL_CONFIGURED_PACKAGES_NAMES)
if(IS_DIRECTORY "${CGAL_SOURCE_DIR}/Documentation")
  # Rescope CGAL_CONFIGURED_PACKAGES_NAMES
  # We need this variable in the Doxygen configuration process. Reset it
  # and change the scope to the parent scope.
  # Philipp Moeller, 2013-05-302013-05-302013-05-30
  set(CGAL_CONFIGURED_PACKAGES_NAMES
      ${CGAL_CONFIGURED_PACKAGES_NAMES}
      PARENT_SCOPE)
endif()

message(STATUS "Packagenames: ${CGAL_CONFIGURED_PACKAGES_NAMES}")
message("== Setting paths (DONE) ==\n")

message("== Generate version files ==")

if(CGAL_BRANCH_BUILD)

  #
  # Create version files
  #

  file(REMOVE ${CGAL_BINARY_DIR}/VERSION)
  if(CGAL_BUGFIX_VERSION AND CGAL_BUGFIX_VERSION GREATER 0)
    set(CGAL_CREATED_VERSION_NUM
        "${CGAL_MAJOR_VERSION}.${CGAL_MINOR_VERSION}.${CGAL_BUGFIX_VERSION}")
  else()
    set(CGAL_CREATED_VERSION_NUM "${CGAL_MAJOR_VERSION}.${CGAL_MINOR_VERSION}")
  endif()

  # Accessed in the documentation.
  set(CGAL_CREATED_VERSION_NUM
      ${CGAL_CREATED_VERSION_NUM}
      PARENT_SCOPE)

  # TODO EBEB set number of internal release (replace "900")
  set(CGAL_BUILD_VERSION 900)
  set(CGAL_CREATED_VERSION
      "${CGAL_CREATED_VERSION_NUM}-I-${CGAL_BUILD_VERSION}")
  set(CGAL_VERSION "${CGAL_CREATED_VERSION_NUM}-I-${CGAL_BUILD_VERSION}")

  file(WRITE "${CGAL_BINARY_DIR}/VERSION" "${CGAL_CREATED_VERSION_NUM}")

  message(STATUS "CGAL_VERSION is ${CGAL_CREATED_VERSION}")
  set(CGAL_FULL_VERSION
      ${CGAL_CREATED_VERSION}
      CACHE INTERNAL "CGAL version")

  #define CGAL_VERSION_NR 1030500135
  string(LENGTH "${CGAL_MAJOR_VERSION}" CGAL_MAJOR_LEN)
  if("${CGAL_MAJOR_LEN}" EQUAL 1)
    set(CGAL_TMP_MAJOR "0${CGAL_MAJOR_VERSION}")
  endif()
  string(LENGTH "${CGAL_MINOR_VERSION}" CGAL_MINOR_LEN)
  if("${CGAL_MINOR_LEN}" EQUAL 1)
    set(CGAL_TMP_MINOR "0${CGAL_MINOR_VERSION}")
  else()
    set(CGAL_TMP_MINOR "${CGAL_MINOR_VERSION}")
  endif()

  set(CGAL_TMP_BUILD "${CGAL_BUILD_VERSION}")
  string(LENGTH "${CGAL_TMP_BUILD}" CGAL_BUILD_LEN)

  while(CGAL_BUILD_LEN LESS 4)
    set(CGAL_TMP_BUILD "0${CGAL_TMP_BUILD}")
    string(LENGTH "${CGAL_TMP_BUILD}" CGAL_BUILD_LEN)
  endwhile()

  set(CGAL_CREATED_VERSION_NR
      "1${CGAL_TMP_MAJOR}${CGAL_TMP_MINOR}${CGAL_BUGFIX_VERSION}${CGAL_TMP_BUILD}"
  )
  message(STATUS "CGAL_VERSION_NR is ${CGAL_CREATED_VERSION_NR}")

  message(STATUS "CGAL_GIT_HASH is ${CGAL_GIT_HASH}")
  message(
    STATUS "CGAL_CREATED_SVN_REVISION is ${CGAL_CREATED_SVN_REVISION} (dummy)")

  file(REMOVE ${CGAL_BINARY_DIR}/include/CGAL/version.h)
  string(TIMESTAMP CGAL_CREATED_RELEASE_DATE "%Y%m%d")
  configure_file(
    ${CGAL_INSTALLATION_PACKAGE_DIR}/cmake/modules/config/version.h.in
    ${CGAL_BINARY_DIR}/include/CGAL/version.h @ONLY)

  #
  # Duplicate files
  #

  if(CGAL_REPORT_DUPLICATE_FILES)

    message("== Searching for duplicate files ==")

    foreach(package ${CGAL_CONFIGURED_PACKAGES})

      file(GLOB_RECURSE CGAL_PACKAGE_HEADER_FILES FOLLOW_SYMLINKS
           ${package}/*.h)
      list(SORT CGAL_PACKAGE_HEADER_FILES)
      foreach(file ${CGAL_PACKAGE_HEADER_FILES})
        string(REPLACE "${package}/" "" pure_file ${file})
        if(NOT ${pure_file} MATCHES ".*CMakeFiles.*")
          list(APPEND CGAL_HEADER_FILES ${pure_file})
        endif()
      endforeach()

      file(GLOB_RECURSE CGAL_PACKAGE_CPP_FILES FOLLOW_SYMLINKS ${package}/*.cpp)
      list(SORT CGAL_PACKAGE_CPP_FILES)
      foreach(file ${CGAL_PACKAGE_CPP_FILES})
        string(REPLACE "${package}/" "" pure_file ${file})
        if(NOT ${pure_file} MATCHES ".*CMakeFiles.*")
          list(APPEND CGAL_CPP_FILES ${pure_file})
        endif()
      endforeach()

    endforeach()

    list(SORT CGAL_HEADER_FILES)
    set(CGAL_UNIQUE_HEADER_FILES ${CGAL_HEADER_FILES})
    set(CGAL_DUPLICATE_HEADER_FILES ${CGAL_HEADER_FILES})
    list(REMOVE_DUPLICATES CGAL_UNIQUE_HEADER_FILES)
    #message(STATUS "Headers: ${CGAL_HEADER_FILES}")
    foreach(file ${CGAL_UNIQUE_HEADER_FILES})
      list(FIND CGAL_DUPLICATE_HEADER_FILES "${file}" CGAL_FILE_IDX)
      list(REMOVE_AT CGAL_DUPLICATE_HEADER_FILES ${CGAL_FILE_IDX})
    endforeach()
    message(
      STATUS
        "Duplicate header files (will be repeated at end): ${CGAL_DUPLICATE_HEADER_FILES}"
    )

    list(SORT CGAL_CPP_FILES)
    set(CGAL_UNIQUE_CPP_FILES ${CGAL_CPP_FILES})
    set(CGAL_DUPLICATE_CPP_FILES ${CGAL_CPP_FILES})
    list(REMOVE_DUPLICATES CGAL_UNIQUE_CPP_FILES)
    #message(STATUS "CPPs: ${CGAL_CPP_FILES}")
    foreach(file ${CGAL_UNIQUE_CPP_FILES})
      list(FIND CGAL_DUPLICATE_CPP_FILES "${file}" CGAL_FILE_IDX)
      list(REMOVE_AT CGAL_DUPLICATE_CPP_FILES ${CGAL_FILE_IDX})
    endforeach()
    message(
      STATUS
        "Duplicate cpp files (will be repeated at end): ${CGAL_DUPLICATE_CPP_FILES}"
    )

  endif(CGAL_REPORT_DUPLICATE_FILES)

else()

  if(NOT EXISTS "${CGAL_SOURCE_DIR}/VERSION"
     OR NOT EXISTS "${CGAL_SOURCE_DIR}/include/CGAL/version.h")
    message(
      FATAL_ERROR
        "File VERSION or include/CGAL/version.h are missing, required by release-build."
    )
  endif()

  #
  # Read and parse CGAL version number from VERSION file
  #

  file(READ "${CGAL_SOURCE_DIR}/VERSION" CGAL_VERSION)
  # Comment from Laurent Rineau, 2012/06/28:
  #   file(READ ..) should be replace by file(STRINGS ..), and then we take
  #   the first line. That would avoid parsing errors when the VERSION file
  #   contains a CR character!

  set(CGAL_FULL_VERSION ${CGAL_VERSION})
  string(REPLACE "-" "." CGAL_VERSION_TOKENS1 ${CGAL_VERSION})
  string(REPLACE "." ";" CGAL_VERSION_TOKENS ${CGAL_VERSION_TOKENS1})
  list(LENGTH CGAL_VERSION_TOKENS CGAL_VERSION_TOKENS_LEN)
  list(GET CGAL_VERSION_TOKENS 0 CGAL_MAJOR_VERSION)

  set(CGAL_MINOR_VERSION)
  set(CGAL_BUGFIX_VERSION)
  set(CGAL_BUILD_VERSION 1000)

  if(CGAL_VERSION_TOKENS_LEN GREATER 1)
    list(GET CGAL_VERSION_TOKENS 1 CGAL_MINOR_VERSION)
  endif()

  if(CGAL_VERSION_TOKENS_LEN GREATER 2)
    list(GET CGAL_VERSION_TOKENS 2 CGAL_BUGFIX_VERSION)

    # The following condition will be true the token #2 is not a number (if
    # it is for example "I" or "Ic"):
    if(NOT CGAL_BUGFIX_VERSION GREATER 0 AND NOT CGAL_BUGFIX_VERSION EQUAL 0)
      set(CGAL_BUGFIX_VERSION 0)
      if(CGAL_VERSION_TOKENS_LEN GREATER 3)
        list(GET CGAL_VERSION_TOKENS 3 CGAL_BUILD_VERSION)
      endif()
    else()
      if(CGAL_VERSION_TOKENS_LEN GREATER 4)
        list(GET CGAL_VERSION_TOKENS 4 CGAL_BUILD_VERSION)
      endif()
    endif()
    # If CGAL_BUILD_VERSION is not a strictly positive number, error
    if(NOT CGAL_BUILD_VERSION GREATER 0)
      message(
        WARNING
          "Error parsing VERSION file: CGAL_BUILD_VERSION is not a number.\n"
          "The content of the VERSION file is:\n${CGAL_VERSION}\n"
          "CGAL_BUILD_VERSION was set to:\n${CGAL_BUILD_VERSION}")
      set(CGAL_BUILD_VERSION 1000)
    endif()
  endif()

  if(NOT CGAL_BUGFIX_VERSION)

=== demo/Bounding_volumes/CMakeLists.txt ===
# Created by the script cgal_create_cmake_script
# This is the CMake script for compiling a CGAL application.

cmake_minimum_required(VERSION 3.12...3.31)
project(Bounding_volumes_Demo)

find_package(CGAL REQUIRED OPTIONAL_COMPONENTS Qt6)

find_package(Qt6 QUIET COMPONENTS Widgets)

find_package(Eigen3 QUIET)
include(CGAL_Eigen3_support)

if(NOT TARGET CGAL::Eigen3_support)
  message("NOTICE: This demo requires CGAL and Eigen, and will not be compiled.")
  return()
endif()

if(CGAL_Qt6_FOUND AND Qt6_FOUND)

  set(CMAKE_INCLUDE_CURRENT_DIR ON)
  add_compile_definitions(QT_NO_KEYWORDS)
  set(CMAKE_AUTOMOC ON)
  set(CMAKE_AUTOUIC ON)
  set(CMAKE_AUTORCC ON)

  qt_add_executable(
    Bounding_volumes Bounding_volumes.cpp Bounding_volumes.ui Bounding_volumes.qrc)

  add_to_cached_list(CGAL_EXECUTABLE_TARGETS Bounding_volumes)

  target_link_libraries(Bounding_volumes PRIVATE CGAL::CGAL CGAL::CGAL_Qt6
                                                 Qt6::Widgets
                                                 CGAL::Eigen3_support)

  include(${CGAL_MODULES_DIR}/CGAL_add_test.cmake)
  cgal_add_compilation_test(Bounding_volumes)

else()

  message("NOTICE: This demo requires CGAL and Qt6, and will not be compiled.")

endif()

=== demo/CGAL_ipelets/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12...3.31)
project(CGAL_ipelets_Demo)

if(NOT POLICY CMP0070 AND POLICY CMP0053)
  # Only set CMP0053 to OLD with CMake<3.10, otherwise there is a warning.
  cmake_policy(SET CMP0053 OLD)
endif()

macro(remove_leading_zero var)
  string(SUBSTRING "${${var}}" 0 1 ONECHAR)
  string(COMPARE EQUAL "${ONECHAR}" "0" ISZERO)
  if(${ISZERO})
    string(SUBSTRING "${${var}}" 1 1 ONECHAR)
    set(${var} ${ONECHAR})
  endif()
endmacro()

#path where to build libraries
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")

find_package(CGAL REQUIRED COMPONENTS Core)

find_package(Eigen3 QUIET)
include(CGAL_Eigen3_support)

if(NOT TARGET CGAL::Eigen3_support)
  message("NOTICE: This project requires the Eigen library, and will not be compiled.")
  return()
endif()

find_package(IPE 7)
if(IPE_FOUND)
  if(NOT ${IPE_VERSION} EQUAL "7")
    message("NOTICE: ${IPE_VERSION} is not a supported version of IPE (only 7 is).")
    set(IPE_FOUND FALSE)
  endif()
endif()

if(IPE_FOUND AND IPE_VERSION)
  message("-- Using IPE version ${IPE_VERSION} compatibility.")

  #setting installation directory
  get_filename_component(IPE_LIBRARY_DIR ${IPE_LIBRARIES} PATH)
  if (IPE_FOUND AND NOT IPELET_INSTALL_DIR)
      remove_leading_zero(IPE_MINOR_VERSION_1)
      remove_leading_zero(IPE_MINOR_VERSION_2)
      set(INSTALL_PATHS "${IPE_LIBRARY_DIR}/ipe/7.${IPE_MINOR_VERSION_1}.${IPE_MINOR_VERSION_2}/ipelets/")
      find_path(IPELET_INSTALL_DIR
                    NAMES libgoodies.lua goodies.lua
                    PATHS ${INSTALL_PATHS}
                    DOC "The folder where ipelets will be installed"
                    ENV IPELETPATH
                   )
  endif()

  set(CGAL_IPELETS ${CGAL_IPELETS})
  set(CGAL_IPELETS ${CGAL_IPELETS} alpha_shapes)
  set(CGAL_IPELETS ${CGAL_IPELETS} arrangement)
  set(CGAL_IPELETS ${CGAL_IPELETS} bbox_restriction)
  set(CGAL_IPELETS ${CGAL_IPELETS} diagrams)
  set(CGAL_IPELETS ${CGAL_IPELETS} hilbert_sort)
  set(CGAL_IPELETS ${CGAL_IPELETS} hull)
  set(CGAL_IPELETS ${CGAL_IPELETS} generator)
  set(CGAL_IPELETS ${CGAL_IPELETS} mesh_2)
  set(CGAL_IPELETS ${CGAL_IPELETS} minkowski)
  set(CGAL_IPELETS ${CGAL_IPELETS} mst)
  set(CGAL_IPELETS ${CGAL_IPELETS} nearest_neighbor_graph)
  set(CGAL_IPELETS ${CGAL_IPELETS} multi_delaunay)
  set(CGAL_IPELETS ${CGAL_IPELETS} multi_regular)
  set(CGAL_IPELETS ${CGAL_IPELETS} partition)
  set(CGAL_IPELETS ${CGAL_IPELETS} pca)
  set(CGAL_IPELETS ${CGAL_IPELETS} skeleton)
  set(CGAL_IPELETS ${CGAL_IPELETS} svdlinf)
  set(CGAL_IPELETS ${CGAL_IPELETS} triangulation)
  set(CGAL_IPELETS ${CGAL_IPELETS} circle_pencils)
  set(CGAL_IPELETS ${CGAL_IPELETS} hyperbolic)
  set(CGAL_IPELETS ${CGAL_IPELETS} distance)
  if(CGAL_Core_FOUND)
    set(CGAL_IPELETS ${CGAL_IPELETS} cone_spanners)
  endif()

  if(IPELET_INSTALL_DIR)
    message(STATUS "Set Ipelets install dir: ${IPELET_INSTALL_DIR}")
  endif()

  include(${CGAL_MODULES_DIR}/CGAL_add_test.cmake)

  foreach(IPELET ${CGAL_IPELETS})
    add_library(CGAL_${IPELET} MODULE ${IPELET}.cpp)
    target_include_directories(CGAL_${IPELET} BEFORE PRIVATE ${IPE_INCLUDE_DIR})

    add_to_cached_list(CGAL_EXECUTABLE_TARGETS CGAL_${IPELET})
    target_link_libraries(CGAL_${IPELET} PRIVATE CGAL::CGAL CGAL::Eigen3_support
                                                 ${IPE_LIBRARIES})
    if(IPELET_INSTALL_DIR)
      install(TARGETS CGAL_${IPELET} DESTINATION ${IPELET_INSTALL_DIR})
      install(FILES ./lua/libCGAL_${IPELET}.lua DESTINATION ${IPELET_INSTALL_DIR}) #only for ipe 7
    endif ()
    cgal_add_compilation_test(CGAL_${IPELET})
  endforeach(IPELET)
  if(CGAL_Core_FOUND)
    target_link_libraries(CGAL_cone_spanners PRIVATE CGAL::CGAL CGAL::CGAL_Core
                                                     CGAL::Eigen3_support)
  endif()
  #example in doc not installed
  add_library(simple_triangulation MODULE simple_triangulation.cpp)
  add_to_cached_list(CGAL_EXECUTABLE_TARGETS simple_triangulation)
  target_link_libraries(simple_triangulation CGAL::CGAL CGAL::Eigen3_support
                        ${IPE_LIBRARIES})
  target_include_directories(simple_triangulation BEFORE PRIVATE ${IPE_INCLUDE_DIR})
  if (WITH_IPE_7)
      target_compile_definitions(simple_triangulation PRIVATE CGAL_USE_IPE_7)
    endif()
  cgal_add_compilation_test(simple_triangulation)

else()
  message("NOTICE: This project requires the Ipe include files and library, and will not be compiled.")
endif()

=== demo/Lab/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.31)
project(Lab_Demo)
include(FeatureSummary)


add_compile_definitions(CGAL_NO_DEPRECATED_CODE)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

#Defines flags to emulate windows behavior for linking error generation
if(CMAKE_CXX_COMPILER_ID STREQUAL Clang
   OR CMAKE_COMPILER_IS_GNUCC
   OR CMAKE_COMPILER_IS_GNUCXX)
  if(UNIX OR APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
  endif()
  if(UNIX AND NOT APPLE)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -z defs")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -z defs")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -z defs")
  endif()
endif()

# Let plugins be compiled in the same directory as the executable.
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")

# Include this package's headers first
include_directories(BEFORE ./ ./include ./CGAL_demo)
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}")

# Find CGAL
find_package(CGAL REQUIRED OPTIONAL_COMPONENTS Qt6 ImageIO)
set_package_properties(CGAL PROPERTIES TYPE REQUIRED)

# Find Qt6 itself
find_package(Qt6 QUIET
             COMPONENTS OpenGLWidgets Widgets Qml
             OPTIONAL_COMPONENTS WebSockets Network)

set_package_properties(
  Qt6 PROPERTIES
  TYPE REQUIRED
  PURPOSE "Enables the 3D Features, for GUI and visualization."
  DESCRIPTION "To find this package, it should be sufficient to fill the Qt6_DIR variable with: <Qt_dir>/<Qt_version>/<Compilator>/lib/cmake/Qt6")

if(Qt6_FOUND)
  add_compile_definitions(QT_NO_KEYWORDS)
endif(Qt6_FOUND)

find_package(Eigen3 QUIET)
include(CGAL_Eigen3_support)

set_package_properties(
  Eigen3 PROPERTIES
  DESCRIPTION "A library for linear algebra."
  PURPOSE "Required for most plugins (Meshing, Mesh and Point Set Processing, etc.).")

if(NOT TARGET CGAL::Eigen3_support)
  message(STATUS "NOTICE: Eigen was not found.")
endif()

find_package(METIS QUIET)
include(CGAL_METIS_support)
set_package_properties(
  METIS PROPERTIES
  DESCRIPTION "A library for graph partitioning."
  PURPOSE "Required for the partition plugin.")

# Activate concurrency?
option(LAB_DEMO_ACTIVATE_CONCURRENCY "Enable concurrency" ON)
if(LAB_DEMO_ACTIVATE_CONCURRENCY)
  find_package(TBB QUIET)
  include(CGAL_TBB_support)
  if(NOT TARGET CGAL::TBB_support)
    message(STATUS "NOTICE: Intel TBB was not found. Bilateral smoothing and WLOP plugins are faster if TBB is linked.")
  endif()
endif()

#find libssh for scene sharing
find_package(LibSSH QUIET)
set_package_properties(
  LibSSH PROPERTIES
  DESCRIPTION "A library implementing the SSH protocol on client and server side. "
  PURPOSE "Required for loading (saving) a scene to (from) a distant server.")
if(NOT LIBSSH_FOUND)
  message(STATUS "NOTICE: The SSH features will be disabled.")
endif()

# Activate concurrency ? (turned OFF by default)
option(CGAL_ACTIVATE_CONCURRENT_MESH_3 "Activate parallelism in Mesh_3" OFF)

# And add -DCGAL_CONCURRENT_MESH_3 if that option is ON
if(CGAL_ACTIVATE_CONCURRENT_MESH_3 OR "$ENV{CGAL_ACTIVATE_CONCURRENT_MESH_3}")
  add_compile_definitions(CGAL_CONCURRENT_MESH_3)
  if(NOT TBB_FOUND)
    find_package(TBB REQUIRED)
    include(CGAL_TBB_support)
    if(NOT TARGET CGAL::TBB_support)
      message(STATUS "NOTICE: Intel TBB was not found. Mesh_3 is faster if TBB is linked.")
    endif()
  endif()
else(CGAL_ACTIVATE_CONCURRENT_MESH_3 OR "$ENV{CGAL_ACTIVATE_CONCURRENT_MESH_3}")
  option(LINK_WITH_TBB "Link with TBB anyway so we can use TBB timers for profiling" ON)
  if(LINK_WITH_TBB)
    find_package(TBB)
    include(CGAL_TBB_support)
  endif(LINK_WITH_TBB)
endif()

set_package_properties(
  TBB PROPERTIES
  DESCRIPTION "A library for parallel programming."
  PURPOSE "Plugins such as Mesh_3, Bilateral smoothing, and WLOP are faster if TBB is linked.")

if(CGAL_Qt6_FOUND AND Qt6_FOUND)
  qt6_wrap_ui(MainWindowUI_files MainWindow.ui)
  qt6_wrap_ui(SubViewerUI_files SubViewer.ui)
  qt6_wrap_ui(statisticsUI_FILES Statistics_on_item_dialog.ui)
  qt6_wrap_ui(FileLoaderDialogUI_files FileLoaderDialog.ui)
  qt6_wrap_ui(Show_point_dialogUI_FILES Show_point_dialog.ui)
  qt6_wrap_ui(PreferencesUI_FILES Preferences.ui Details.ui SSH_dialog.ui)
  qt6_wrap_ui(Show_point_dialogUI_FILES Show_point_dialog.ui)
  qt6_wrap_ui(ViewerUI_FILES LightingDialog.ui)
  qt6_generate_moc("File_loader_dialog.h"
                   "${CMAKE_CURRENT_BINARY_DIR}/File_loader_dialog_moc.cpp")

  include(${CMAKE_CURRENT_SOURCE_DIR}/CGALlab_macros.cmake)

  qt6_add_resources(CGAL_Qt6_RESOURCE_FILES CGALlab.qrc)
  find_path(
    CGAL_THREE_HEADERS_PATH
    NAMES CGAL/Three/Scene_item.h
    HINTS ${CGAL_INCLUDE_DIRS}
    NO_DEFAULT_PATH NO_CMAKE_FIND_ROOT_PATH
    DOC "Path to CGAL/Three/Scene_item.h")

  if(CGAL_THREE_HEADERS_PATH)
    qt6_generate_moc("${CGAL_THREE_HEADERS_PATH}/CGAL/Three/Viewer_interface.h"
                     "${CMAKE_CURRENT_BINARY_DIR}/Viewer_interface_moc.cpp")
    qt6_generate_moc("${CGAL_THREE_HEADERS_PATH}/CGAL/Three/Scene_item.h"
                     "${CMAKE_CURRENT_BINARY_DIR}/Scene_item_moc.cpp")
    qt6_generate_moc("${CGAL_THREE_HEADERS_PATH}/CGAL/Three/Scene_group_item.h"
                     "${CMAKE_CURRENT_BINARY_DIR}/Scene_group_item_moc.cpp")
    qt6_generate_moc(
      "${CGAL_THREE_HEADERS_PATH}/CGAL/Three/Scene_item_rendering_helper.h"
      "${CMAKE_CURRENT_BINARY_DIR}/Scene_item_rendering_helper_moc.cpp")
    qt6_generate_moc("${CGAL_THREE_HEADERS_PATH}/CGAL/Three/TextRenderer.h"
                     "${CMAKE_CURRENT_BINARY_DIR}/TextRenderer_moc.cpp")
  else()
    message(FATAL_ERROR "Cannot find <CGAL/Three/Scene_item.h>")
  endif()

  unset(CGAL_THREE_HEADERS_PATH CACHE)

  # AUXILIARY LIBRARIES

  # put plugins (which are shared libraries) at the same location as
  # executable files
  set(CGAL_LAB_DEMO_PLUGINS_DIR "${RUNTIME_OUTPUT_PATH}")
  set(LIBRARY_OUTPUT_PATH "${CGAL_LAB_DEMO_PLUGINS_DIR}")

  add_library(
    demo_framework SHARED
    Scene.cpp
    Viewer.cpp
    Three.cpp
    ${ViewerUI_FILES}
    ${CGAL_Qt6_RESOURCE_FILES}
    ${CGAL_Qt6_MOC_FILES}
    Viewer_interface_moc.cpp
    Scene_item_moc.cpp
    Scene_item.cpp
    Scene_item_with_properties.cpp
    Triangle_container.cpp
    Edge_container.cpp
    Point_container.cpp
    Scene_group_item.cpp
    Scene_group_item_moc.cpp
    TextRenderer.cpp
    TextRenderer_moc.cpp
    Scene_item_rendering_helper.cpp
    Scene_item_rendering_helper_moc.cpp
    Primitive_container.cpp
    CGALlab_plugin_helper.cpp
    CGAL_double_edit.cpp)
  target_link_libraries(demo_framework PRIVATE Qt6::OpenGLWidgets Qt6::Widgets Qt6::Gui
                                       PUBLIC CGAL::CGAL_Qt6)
  if(TARGET Qt6::WebSockets)
    target_link_libraries(demo_framework PRIVATE Qt6::WebSockets)
    message(STATUS "Qt6WebSockets was found. Using WebSockets is therefore possible.")
  endif()

  # This custom target is useless. It is used only as a flag to
  # detect that the test has already been created.
  add_custom_target("compilation_of__demo_framework")
  cgal_add_compilation_test(demo_framework)
  if(TEST "compilation of  demo_framework")
    set_property(TEST "compilation of  demo_framework"
      APPEND PROPERTY LABELS "CGAL_build_system" "Installation" "${PROJECT_NAME}")
    set_property(TEST "compilation of  demo_framework"
      APPEND PROPERTY FIXTURES_SETUP "demo_framework_SetupFixture")
    set_property(TEST "compilation of  demo_framework"
      APPEND PROPERTY DEPENDS "check build system" "compilation of  CGAL_Qt6_moc_and_resources")
  endif()

  # Let's define `three_EXPORT` during the compilation of `demo_framework`,
  # in addition of `demo_framework_EXPORT` (defined automatically by
  # CMake). That is to deal with the visibility of symbols of
  # `Three.h`/`Three.cpp`.
  target_compile_definitions(demo_framework PRIVATE three_EXPORTS=1)
  target_compile_definitions(demo_framework PRIVATE -DCGAL_USE_Qt6_RESOURCES)

  add_library(scene_basic_objects SHARED Scene_plane_item.cpp
                                         Scene_spheres_item.cpp)
  target_link_libraries(
    scene_basic_objects PRIVATE demo_framework CGAL::CGAL_Qt6 Qt6::OpenGLWidgets
                                Qt6::Gui Qt6::Widgets)
  add_library(scene_color_ramp SHARED Color_ramp.cpp)
  target_link_libraries(scene_color_ramp PRIVATE Qt6::Core)

  add_library(scene_callback_signaler SHARED Callback_signaler.cpp)
  target_link_libraries(scene_callback_signaler PRIVATE Qt6::Core)

  add_library(point_dialog SHARED Show_point_dialog.cpp Show_point_dialog.ui
                                  ${Show_point_dialogUI_FILES})
  target_link_libraries(point_dialog PRIVATE Qt6::OpenGLWidgets Qt6::Gui
                                            Qt6::Widgets)
  cgal_add_compilation_test(point_dialog)

  macro(add_item item_name)
    add_library(${item_name} SHARED ${ARGN})
    target_link_libraries(
      ${item_name} PRIVATE demo_framework CGAL::CGAL_Qt6 Qt6::OpenGLWidgets Qt6::Gui
                           Qt6::Widgets)
    cgal_add_compilation_test(${item_name})
    add_to_cached_list(CGAL_EXECUTABLE_TARGETS ${item_name})
    CGAL_install_hooks()
  endmacro(add_item)

  add_item(scene_triangulation_3_item Scene_triangulation_3_item.cpp)
  target_link_libraries(scene_triangulation_3_item PRIVATE scene_basic_objects scene_edit_box_item)

  add_item(scene_c3t3_item Scene_c3t3_item.cpp)
  target_link_libraries(
    scene_c3t3_item
    PUBLIC
    scene_triangulation_3_item
    PRIVATE
    scene_surface_mesh_item scene_polygon_soup_item
    scene_basic_objects ${TBB_LIBRARIES})

  add_item(scene_tetrahedra_item Scene_tetrahedra_item.cpp)
  target_link_libraries(scene_tetrahedra_item PRIVATE scene_c3t3_item)


  # Support for precompiled headers, for Mesh_3 (since CMake 3.16)
  add_library(c3t3_type_pch OBJECT c3t3_type_pch_empty_source.cpp C3t3_type.h)
  target_link_libraries(c3t3_type_pch PRIVATE CGAL::CGAL_Qt6 Qt6::OpenGLWidgets Qt6::Gui)
  set_property(TARGET c3t3_type_pch PROPERTY POSITION_INDEPENDENT_CODE TRUE)
  if(TARGET CGAL::TBB_support)
    target_link_libraries(c3t3_type_pch PRIVATE CGAL::TBB_support)
  endif()
  # target_precompile_headers(c3t3_type_pch PRIVATE [["C3t3_type.h"]])

  function(CGAL_Lab_target_use_c3t3_type target)
    target_link_libraries(${target} PRIVATE c3t3_type_pch)
    # target_precompile_headers(${target} REUSE_FROM c3t3_type_pch)
    if(TARGET CGAL::TBB_support)
      target_link_libraries(${target} PRIVATE CGAL::TBB_support)
    endif()
  endfunction(CGAL_Lab_target_use_c3t3_type)

  CGAL_Lab_target_use_c3t3_type(scene_c3t3_item)
  CGAL_Lab_target_use_c3t3_type(scene_triangulation_3_item)
  CGAL_Lab_target_use_c3t3_type(scene_tetrahedra_item)

  add_item(scene_aff_transformed_item Plugins/PCA/Scene_aff_transformed_item.cpp)

  add_item(scene_aff_transformed_point_set_item Plugins/PCA/Scene_aff_transformed_point_set_item.cpp)
  target_link_libraries(scene_aff_transformed_point_set_item PRIVATE scene_points_with_normal_item
                                                                     scene_aff_transformed_item)
  add_item(scene_aff_transformed_polygon_soup_item Plugins/PCA/Scene_aff_transformed_polygon_soup_item.cpp)
  target_link_libraries(scene_aff_transformed_polygon_soup_item PRIVATE scene_polygon_soup_item
                                                                        scene_aff_transformed_item)
  add_item(scene_aff_transformed_surface_mesh_item Plugins/PCA/Scene_aff_transformed_surface_mesh_item.cpp)
  target_link_libraries(scene_aff_transformed_surface_mesh_item PRIVATE scene_surface_mesh_item
                                                                        scene_aff_transformed_item)

  add_item(scene_edit_box_item Plugins/PCA/Scene_edit_box_item.cpp)

  add_item(scene_image_item Scene_image_item.cpp)

=== demo/Polygon/CMakeLists.txt ===
# Created by the script cgal_create_cmake_script
# This is the CMake script for compiling a CGAL application.

cmake_minimum_required(VERSION 3.12...3.31)
project(Polygon_Demo)

find_package(CGAL REQUIRED OPTIONAL_COMPONENTS Qt6 Core)

find_package(Eigen3 QUIET)
include(CGAL_Eigen3_support)

if(NOT TARGET CGAL::Eigen3_support)
  message("NOTICE: This demo requires the Eigen library, and will not be compiled.")
  return()
endif()

find_package(Qt6 QUIET COMPONENTS Widgets)

if(CGAL_Qt6_FOUND AND Qt6_FOUND)
  add_compile_definitions(QT_NO_KEYWORDS)
  set(CMAKE_AUTOMOC ON)
  set(CMAKE_AUTOUIC ON)
  set(CMAKE_AUTORCC ON)

  if(CGAL_Core_FOUND)
    add_compile_definitions(CGAL_USE_CORE)
  endif()

  qt_add_executable(Polygon_2 Polygon_2.cpp
                    Polygon_2.ui Polygon_2.qrc)

  add_to_cached_list(CGAL_EXECUTABLE_TARGETS Polygon_2)

  target_link_libraries(Polygon_2 PRIVATE CGAL::CGAL CGAL::CGAL_Qt6
                                          CGAL::Eigen3_support Qt6::Widgets)

  include(${CGAL_MODULES_DIR}/CGAL_add_test.cmake)
  cgal_add_compilation_test(Polygon_2)
else()
  message("NOTICE: This demo requires CGAL, CGAL_Core, and Qt6, and will not be compiled.")
endif()

=== demo/Principal_component_analysis/CMakeLists.txt ===
# This is the CMake script for compiling the PCA demo.

cmake_minimum_required(VERSION 3.12...3.31)
project(Principal_component_analysis_Demo)

include_directories(./)

# Find CGAL and CGAL Qt6
find_package(CGAL REQUIRED OPTIONAL_COMPONENTS Qt6)

find_package(Eigen3 QUIET)
include(CGAL_Eigen3_support)

if(NOT TARGET CGAL::Eigen3_support)
  message("NOTICE: This project requires the Eigen library, and will not be compiled.")
  return()
endif()

# Find Qt6 itself
find_package(Qt6 QUIET COMPONENTS Widgets OpenGL)

if(CGAL_Qt6_FOUND AND Qt6_FOUND)

  set(CMAKE_INCLUDE_CURRENT_DIR ON)
  set(CMAKE_AUTOMOC ON)
  set(CMAKE_AUTOUIC ON)
  set(CMAKE_AUTORCC ON)

  qt_add_executable(PCA_demo PCA_demo.cpp MainWindow.ui MainWindow.cpp Viewer.cpp Scene.cpp)

  target_link_libraries(PCA_demo PRIVATE CGAL::CGAL CGAL::CGAL_Qt6
                                         CGAL::Eigen3_support Qt6::Widgets Qt6::OpenGL)

  add_to_cached_list(CGAL_EXECUTABLE_TARGETS PCA_demo)

  include(${CGAL_MODULES_DIR}/CGAL_add_test.cmake)
  cgal_add_compilation_test(PCA_demo)

else(CGAL_Qt6_FOUND AND Qt6_FOUND)

  set(PCA_MISSING_DEPS "")

  if(NOT CGAL_Qt6_FOUND)
    set(PCA_MISSING_DEPS "the CGAL Qt6 library, ${PCA_MISSING_DEPS}")
  endif()

  if(NOT Qt6_FOUND)
    set(PCA_MISSING_DEPS "Qt6, ${PCA_MISSING_DEPS}")
  endif()

  message("NOTICE: This demo requires ${PCA_MISSING_DEPS} and will not be compiled.")

endif(CGAL_Qt6_FOUND AND Qt6_FOUND)

=== demo/Surface_mesh_deformation/CMakeLists.txt ===
# Created by the script cgal_create_cmake_script
# This is the CMake script for compiling a CGAL application.

cmake_minimum_required(VERSION 3.12...3.31)
project(Surface_mesh_deformation_Demo)

set_property(DIRECTORY PROPERTY CGAL_NO_TESTING TRUE)

find_package(CGAL REQUIRED)

find_package(Eigen3 QUIET)
include(CGAL_Eigen3_support)

if(TARGET CGAL::Eigen3_support)
  create_single_source_cgal_program("deform_mesh_for_botsch08_format.cpp")
  target_link_libraries(deform_mesh_for_botsch08_format PRIVATE CGAL::Eigen3_support)
else()
  message("NOTICE: This program requires requires Eigen 3.1.91 (or greater) or later and will not be compiled.")
endif()

=== demo/Triangulation_3/CMakeLists.txt ===
# Created by the script cgal_create_cmake_script
# This is the CMake script for compiling a CGAL application.

cmake_minimum_required(VERSION 3.12...3.31)
project(Triangulation_3_Demo)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(CGAL REQUIRED OPTIONAL_COMPONENTS Qt6)

find_package(Qt6 QUIET COMPONENTS Widgets OpenGL)

if(Qt6_FOUND)
  add_compile_definitions(QT_NO_KEYWORDS)
  set(CMAKE_INCLUDE_CURRENT_DIR ON)
endif(Qt6_FOUND)

# Activate concurrency ? (turned OFF by default)
option(CGAL_ACTIVATE_CONCURRENT_TRIANGULATION_3
       "Activate parallelism in Triangulation_3" OFF)

# And add -DCGAL_CONCURRENT_TRIANGULATION_3 if that option is ON
if(CGAL_ACTIVATE_CONCURRENT_TRIANGULATION_3)
  add_compile_definitions(CGAL_CONCURRENT_TRIANGULATION_3)
  find_package(TBB REQUIRED)
  include(CGAL_TBB_support)
else(CGAL_ACTIVATE_CONCURRENT_TRIANGULATION_3)
  option(LINK_WITH_TBB
         "Link with TBB anyway so we can use TBB timers for profiling" ON)
  if(LINK_WITH_TBB)
    find_package(TBB)
    include(CGAL_TBB_support)
  endif(LINK_WITH_TBB)
endif()

if(CGAL_Qt6_FOUND AND Qt6_FOUND)

  include_directories(BEFORE ./)
  set(CMAKE_AUTOMOC ON)
  set(CMAKE_AUTOUIC ON)
  set(CMAKE_AUTORCC ON)

  # cpp files
  qt_add_executable(
    T3_demo
    T3_demo.cpp
    MainWindow.cpp
    Viewer.cpp
    PreferenceDlg.cpp
    Scene.cpp
    MainWindow.ui
    T3_demo.qrc)

  add_to_cached_list(CGAL_EXECUTABLE_TARGETS T3_demo)

  target_link_libraries(T3_demo PRIVATE CGAL::CGAL CGAL::CGAL_Qt6)
  target_link_libraries(T3_demo PRIVATE Qt6::OpenGL)
  if(TARGET CGAL::TBB_support)
    target_link_libraries(T3_demo PRIVATE CGAL::TBB_support)
  endif()

  include(${CGAL_MODULES_DIR}/CGAL_add_test.cmake)
  cgal_add_compilation_test(T3_demo)

else(CGAL_Qt6_FOUND AND Qt6_FOUND)

  set(TRIANGULATION_3_MISSING_DEPS "")

  if(NOT CGAL_Qt6_FOUND)
    set(TRIANGULATION_3_MISSING_DEPS
        "the CGAL Qt6 library, ${TRIANGULATION_3_MISSING_DEPS}")
  endif()

  if(NOT Qt6_FOUND)
    set(TRIANGULATION_3_MISSING_DEPS "Qt6, ${TRIANGULATION_3_MISSING_DEPS}")
  endif()

  message("NOTICE: This demo requires ${TRIANGULATION_3_MISSING_DEPS}, and will not be compiled.")

endif(CGAL_Qt6_FOUND AND Qt6_FOUND)

=== demo/Triangulation_on_sphere_2/CMakeLists.txt ===
# Created by the script cgal_create_cmake_script
# This is the CMake script for compiling a CGAL application.

cmake_minimum_required(VERSION 3.12...3.31)

project (Triangulation_on_sphere_2_Demo)

set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# Find CGAL and CGAL Qt6
find_package(CGAL REQUIRED OPTIONAL_COMPONENTS Qt6)

# Find Qt6 itself
find_package(Qt6 QUIET COMPONENTS Widgets OpenGL)

find_package(Eigen3 QUIET)
include(CGAL_Eigen3_support)

if(CGAL_Qt6_FOUND AND Qt6_FOUND AND TARGET CGAL::Eigen3_support)
  # Include this package's headers first
  include_directories(BEFORE ./ ./include)

  set(CMAKE_AUTOUIC ON)

  qt_add_executable  ( Triangulation_on_sphere_2_Demo main.cpp Viewer.cpp)

  add_to_cached_list( CGAL_EXECUTABLE_TARGETS Triangulation_on_sphere_2_Demo )

  target_link_libraries( Triangulation_on_sphere_2_Demo PRIVATE CGAL::CGAL CGAL::CGAL_Qt6 Qt6::OpenGL Qt6::Widgets CGAL::Eigen3_support)

  include(${CGAL_MODULES_DIR}/CGAL_add_test.cmake)
  cgal_add_compilation_test( Triangulation_on_sphere_2_Demo )
else()
  message("NOTICE: This demo requires CGAL, Qt6, and Eigen, and will not be compiled.")
endif()

=== examples/Approximate_min_ellipsoid_d/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12...3.31)
project(Approximate_min_ellipsoid_d_Examples)

find_package(CGAL REQUIRED)

# Use Eigen
find_package(Eigen3 QUIET)
include(CGAL_Eigen3_support)

# create a target per cppfile
file(
  GLOB cppfiles
  RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp)
foreach(cppfile ${cppfiles})
  if(NOT (${cppfile} STREQUAL "ellipsoid.cpp") OR TARGET CGAL::Eigen3_support)
    get_filename_component(target ${cppfile} NAME_WE)
    create_single_source_cgal_program(${cppfile})
    if(TARGET CGAL::Eigen3_support)
      target_link_libraries(${target} PRIVATE CGAL::CGAL CGAL::Eigen3_support)
    else()
      target_link_libraries(${target} PRIVATE CGAL::CGAL)
    endif()
  endif()
endforeach()

=== examples/Barycentric_coordinates_2/CMakeLists.txt ===
# Created by the script cgal_create_cmake_script.
# This is the CMake script for compiling a CGAL application.

cmake_minimum_required(VERSION 3.12...3.31)

project(Barycentric_coordinates_2_Examples)

find_package(CGAL REQUIRED COMPONENTS Core)

create_single_source_cgal_program("segment_coordinates.cpp")
create_single_source_cgal_program("triangle_coordinates.cpp")
create_single_source_cgal_program("wachspress_coordinates.cpp")
create_single_source_cgal_program("mean_value_coordinates.cpp")
create_single_source_cgal_program("discrete_harmonic_coordinates.cpp")
create_single_source_cgal_program("terrain_height_modeling.cpp")

# this code is deprecated:
create_single_source_cgal_program("deprecated_coordinates.cpp")

find_package(Eigen3 QUIET)
include(CGAL_Eigen3_support)

if(TARGET CGAL::Eigen3_support)
  create_single_source_cgal_program("affine_coordinates.cpp")
  target_link_libraries(affine_coordinates PRIVATE CGAL::Eigen3_support)
  create_single_source_cgal_program("harmonic_coordinates.cpp")
  target_link_libraries(harmonic_coordinates PRIVATE CGAL::Eigen3_support)
  create_single_source_cgal_program("shape_deformation.cpp")
  target_link_libraries(shape_deformation PRIVATE CGAL::Eigen3_support)
else()
  message(STATUS "NOTICE: Several examples require the Eigen library, and will not be compiled.")
endif()

=== examples/Basic_viewer/CMakeLists.txt ===
# Created by the script cgal_create_cmake_script
# This is the CMake script for compiling a CGAL application.

#/!\ /!\
#/!\ /!\
# Used in /CGAL/Documentation/doc/Documentation/Developer_manual/create_and_use_a_cmakelist.txt.
# Careful when modifying

cmake_minimum_required(VERSION 3.12...3.31)
project(Basic_viewer_Examples)

#CGAL_Qt6 is needed for the drawing.
find_package(CGAL REQUIRED OPTIONAL_COMPONENTS Qt6)
find_package(Eigen3 QUIET)
include(CGAL_Eigen3_support)

create_single_source_cgal_program("draw_lcc.cpp")
create_single_source_cgal_program("draw_surface_mesh_height.cpp")
create_single_source_cgal_program("draw_surface_mesh_small_faces.cpp")
create_single_source_cgal_program("draw_surface_mesh_vcolor.cpp")

if(CGAL_Qt6_FOUND)
  #link it with the required CGAL libraries
  target_link_libraries(draw_lcc PRIVATE CGAL::CGAL_Basic_viewer)
  target_link_libraries(draw_surface_mesh_height PRIVATE CGAL::CGAL_Basic_viewer)
  target_link_libraries(draw_surface_mesh_small_faces PRIVATE CGAL::CGAL_Basic_viewer)
  target_link_libraries(draw_surface_mesh_vcolor PRIVATE CGAL::CGAL_Basic_viewer)
  if(TARGET CGAL::Eigen3_support)
    create_single_source_cgal_program("draw_mesh_and_points.cpp")
    create_single_source_cgal_program("draw_several_windows.cpp")
    target_link_libraries(draw_mesh_and_points PRIVATE CGAL::Eigen3_support CGAL::CGAL_Basic_viewer)
    target_link_libraries(draw_several_windows PRIVATE CGAL::Eigen3_support CGAL::CGAL_Basic_viewer)
  else()
    message("Eigen3 is not found, examples that require Eigen3 will not be compiled.")
  endif()
else()
  message("CGAL_Qt6 not configured: examples that require Qt will not be compiled.")
endif()

#end of the file

=== debian/changelog ===
cgal (6.1.1-2) unstable; urgency=medium

  * Remove libboost-system-dev from Build-Depends: and Depends:
    (Closes: #1127178).

 -- Joachim Reichel <reichel@debian.org>  Fri, 06 Feb 2026 16:13:13 +0100

cgal (6.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Joachim Reichel <reichel@debian.org>  Mon, 26 Jan 2026 16:50:20 +0100

=== debian/control ===
Source: cgal
Priority: optional
Maintainer: Joachim Reichel <reichel@debian.org>
# "ipe" is only needed because it contains goodies.lua which is needed by FindIPE.cmake
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dpkg-awk,
 ipe,
 libboost-dev,
 libboost-program-options-dev,
 libboost-thread-dev,
 libeigen3-dev,
 libglu1-mesa-dev,
 libgmp-dev,
 libipe-dev,
 libmpfr-dev,
 qt6-base-dev [!armel !armhf],
 qt6-base-dev-tools [!armel !armhf],
 qt6-svg-dev [!armel !armhf],
 qt6-tools-dev [!armel !armhf],
 tar (>= 1.28),
 zlib1g-dev
Standards-Version: 4.7.0
Section: libs
Rules-Requires-Root: no
Homepage: https://www.cgal.org/
Vcs-Git: https://salsa.debian.org/reichel/cgal.git
Vcs-Browser: https://salsa.debian.org/reichel/cgal

Package: libcgal-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libboost-dev,
 libboost-program-options-dev,
 libboost-thread-dev,
 libgmp-dev,
 libmpfr-dev,
 zlib1g-dev,
 ${misc:Depends}
Suggests:
 libmpfi-dev,
 libntl-dev,
 libtbb-dev
Description: C++ library for computational geometry (development files)
 CGAL (Computational Geometry Algorithms Library) makes the most important
 of the solutions and methods developed in computational geometry available
 to users in industry and academia in a C++ library. The goal is to provide
 easy access to useful, reliable geometric algorithms.
 .
 This package contains most of the header files. The header files for
 visualization with Qt can be found in the package libcgal-qt6-dev.

Package: libcgal-qt6-dev
Section: libdevel
# actually "Architecture: any [!armel !armhf]" via debhelper
Architecture: any
Multi-Arch: same
Replaces: libcgal-qt5-dev (<< 6.0~)
Breaks: libcgal-qt5-dev (<< 6.0~)
Depends:
 libcgal-dev,
 qt6-base-dev,
 qt6-base-dev-tools,
 qt6-svg-dev,
 qt6-tools-dev,
 ${misc:Depends}
Description: C++ library for computational geometry (development files, support for Qt6)
 CGAL (Computational Geometry Algorithms Library) makes the most important
 of the solutions and methods developed in computational geometry available
 to users in industry and academia in a C++ library. The goal is to provide
 easy access to useful, reliable geometric algorithms.
 .
 This package contains the header files for visualization with Qt.

Package: libcgal-demo
Section: devel
Architecture: all
Multi-Arch: foreign
Depends: libcgal-dev (>= ${binary:Version}), ${misc:Depends}
Recommends: libcgal-qt6-dev (>= ${binary:Version})
Suggests:
 cimg-dev,
 geomview,
 gfortran,
 lib3mf-dev,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-serialization-dev,
 libceres-dev,
 libeigen3-dev,
 libglew-dev,
 libglpk-dev,
 libinsighttoolkit5-dev,
 libipe-dev,
 liblapack-dev,
 libmagick++-dev,
 libmetis-dev,
 libmpfi-dev,
 libntl-dev,
 libopencv-dev,
 libopenmesh-dev,
 libssh-dev,
 libsuitesparse-dev,
 libtbb-dev,
 libvtk9-dev,
 nlohmann-json3-dev,
 qt6-base-dev,
 qt6-base-dev-tools,
 qt6-svg-dev,
 qt6-tools-dev,
 qt6-websockets-dev,
 vtk9
Description: C++ library for computational geometry (demos)
 CGAL (Computational Geometry Algorithms Library) makes the most important
 of the solutions and methods developed in computational geometry available
 to users in industry and academia in a C++ library. The goal is to provide
 easy access to useful, reliable geometric algorithms.
 .
 This package contains the demos and examples.

Package: libcgal-ipelets
Section: graphics
Architecture: any
Depends: ipe (>= ${Ipe-Version}), ipe (<< ${Ipe-Version}+),
 ${shlibs:Depends}, ${misc:Depends}
Description: C++ library for computational geometry (ipelets)
 CGAL (Computational Geometry Algorithms Library) makes the most important
 of the solutions and methods developed in computational geometry available
 to users in industry and academia in a C++ library. The goal is to provide
 easy access to useful, reliable geometric algorithms.
 .
 This package contains the ipelets, i.e., plugins for ipe.
